TEC_ID_SEARCH=1
TEC_ID_NAVIGATE=2
TEC_ID_MILITARY=3

function doDevelop() {
    var result = false;
    var e = this.empire
    var yosan = parseInt(this.yosan_p * e.totalDpl() / 100);
    if (yosan > e.trs) {
        yosan = e.trs;
    }
    if (yosan <= 0) {
        return result;
    }
    var minus_cost = 0;
       e[this.ptag_name] += yosan;
    var cost =  (e[this.tag_name] + 1) * (e[this.tag_name] + 1) * 2;
    var trade = app.trade.tDic[e.id];
    if (trade) {
        var max_e = (trade[this.tag_name + "List"]
                ? trade[this.tag_name + "List"][0]: null);
        if (max_e && (max_e.empire[this.tag_name] > e[this.tag_name]) ) {
            var minus_level = e[this.tag_name]
                    - (max_e.empire[this.tag_name] - e[this.tag_name]) + 1;
            minus_cost = cost - minus_level * minus_level * 2;
printConsole(e.id, e.name + "は隣接する他国家のため、" + this.name + "開発のコストが" + minus_cost + "下がります");
        }
    }
    cost -= minus_cost;
printConsole(e.id, e.name + "は" + this.name + "技術の開発に予算" + yosan + "TUを投じます。");
    if (e[this.ptag_name] >= cost) {
         e[this.ptag_name] -= cost;
         e[this.tag_name] += 1;
printConsole(e.id, e.name + "の" + this.name + "技術がレベル" + e[this.tag_name] + "に上がりました");
        result = true;
    } else {
printConsole(e.id, e.name + "の" + this.name + "開発は" + e[this.ptag_name]
        + "に達しました。次のレベルに必要な費用は" + cost + "です。");
    }
    var tmp_tag = "tmp_" + this.tag_name;
    e[tmp_tag] = e[tmp_tag] - yosan;
    e.trs -= yosan;
    return result;
}

// 探査技術
function TecSearch(empire) {

    this.empire = empire;
    this.id = TEC_ID_SEARCH;
    this.name = "探査技術";
    this.tag_name = "fnd";
    this.ptag_name = "fnd_p";
    this.yosan_p = 0;

    this.superDoDevelop = doDevelop;
    this.doDevelop = function() {
        if (this.superDoDevelop()) {
            this.empire.makeVisibleList();
        }
    }
}

// 航宙技術
function TecNavigate(empire) {

    this.empire = empire;
    this.id = TEC_ID_NAVIGATE;
    this.name = "航宙技術";
    this.tag_name = "nvg";
    this.ptag_name = "nvg_p";
    this.yosan_p = 0;

    this.doDevelop = doDevelop;
}

// 軍事技術
function TecMilitary(empire) {

    this.empire = empire;
    this.id = TEC_ID_MILITARY;
    this.name = "軍事技術";
    this.tag_name = "mlt";
    this.ptag_name = "mlt_p";
    this.yosan_p = 0;

    this.doDevelop = doDevelop;
}