// トレード処理クラス
function Trade(empire_list) {
    this.tList = new Array();
    this.tDic = new Object();
    this.tEach = new Object();
    for (var i = 0; i < empire_list.length; i++) {
        var tObj = new Object();
        tObj.empire = empire_list[i];
        tObj.max_fnd = tObj.empire.fnd;
        tObj.max_nvg = tObj.empire.nvg;
        tObj.max_mlt = tObj.empire.mlt;
        tObj.fndList = null;
        tObj.nvgList = null;
        tObj.mltList = null;
        tObj.trade = 0;
        this.tList.push(tObj);
        this.tDic[tObj.empire.id] = tObj;
    }
    for (var i = 0; i < empire_list.length; i++) {
        var e1 = empire_list[i];
        if (e1.totalDpl() <= 0) {
            continue;
        }
        var t1 = this.tList[i];
        for (var j = i + 1; j < empire_list.length; j++) {
            var e2 = empire_list[j];
            if (e2.totalDpl() <= 0) {
                continue;
            }
            var t2 = this.tList[j];
            if (checkRoute(empire_list[i], empire_list[j]) ) {
            } else {
               continue;
            }
            paras = ("nvg", "fnd", "mlt");
            for (var p in paras) {
                para = paras[p];
            }
            if (e1.nvg > e2.nvg) {
                if (e1.nvg >= t2.max_nvg) {
                    t2.max_nvg = e1.nvg;
                    t2.nvgList = new Array(t1);
                } else if (e1.nvg == t2.max_nvg) {
                    if (t2.nvgList) {
                        t2.nvgList.push(t1);
                    } else {
                        t2.nvgList = new Array(t1);
                    }
                }
            } else if (e1.nvg < e2.nvg) {
                if (e2.nvg > t1.max_nvg) {
                    t1.max_nvg = e2.nvg;
                    t1.nvgList = new Array(t2);
                } else if (e2.nvg == t1.max_nvg) {
                    if (t1.nvgList) {
                        t1.nvgList.push(t2);
                    } else {
                        t1.nvgList = new Array(t2);
                    }
                }
            }
            if (e1.fnd > e2.fnd) {
                if (e1.fnd > t2.max_fnd) {
                    t2.max_fnd = e1.fnd;
                    t2.fndList = new Array(t1);
                } else if (e1.fnd == t2.max_fnd) {
                    if (t2.fndList) {
                        t2.fndList.push(t1);
                    } else {
                        t2.fndList = new Array(t1);
                    }
                }
            } else if (e1.fnd < e2.fnd) {
                if (e2.fnd > t1.max_fnd) {
                    t1.max_fnd = e2.fnd;
                    t1.fndList = new Array(t2);
                } else if (e2.fnd == t1.max_fnd) {
                    if (t1.fndList) {
                        t1.fndList.push(t2);
                    } else {
                        t1.fndList = new Array(t2);
                    }
                }
            }
            if (e1.mlt > e2.mlt) {
                if (e1.mlt > t2.max_mlt) {
                    t2.max_mlt = e1.mlt;
                    t2.mltList = new Array(t1);
                } else if (e1.mlt == t2.max_mlt) {
                    if (t2.mltList) {
                        t2.mltList.push(t1);
                    } else {
                        t2.mltList = new Array(t1);
                    }
                }
            } else if (e1.mlt < e2.mlt) {
                if (e2.mlt > t1.max_mlt) {
                    t1.max_mlt = e2.mlt;
                    t1.mltList = new Array(t2);
                } else if (e2.mlt == t1.max_mlt) {
                    if (t1.mltList) {
                        t1.mltList.push(t2);
                    } else {
                        t1.mltList = new Array(t2);
                    }
                }
            }
        }
    }

    for (var i = 0; i < tList.length; i++)  {
        var e1 = empireList[i];
        if (e1.totalDpl() <= 0) {
            continue;
        }
        var t1 = this.tList[i];
        var totalDpl = e1.totalDpl() + 0.0;
        var p = 3.0;
        for (var j = 0; j < tList.length; j++) {
            if (i == j) {
                continue;
            }
            var e2 = empireList[j];
            if (e2.totalDpl() <= 0) {
                continue;
            }
            var t2 = this.tList[j];
            if (! checkRoute(e1, e2) ) {
                continue;
            }
            var p1 = 0.0;
            var p2 = p;
            var key1 = e1.id + "-" + e2.id;
            var key2 = e2.id + "-" + e1.id;
            if (! this.tEach[key1]) {
                this.tEach[key1] = 0;
            }
            if (! this.tEach[key2]) {
                this.tEach[key2] = 0;
            }

            if (e2.fnd > e1.fnd) {
                for (var ix = 0; ix < t1.fndList.length; ix++) {
                    if (t1.fndList[ix].empire.id == e2.id) {
                        var d = (t1.max_fnd - t1.empire.fnd);
                        d = (d > 4.0) ? 4.0 : d;
                        p2 += (d * 3.0) / t1.fndList.length;
                        p1 -= (d * 2.0) / t1.fndList.length;
                        break;
                    }
                }
            }

           if (e2.nvg > e1.nvg) {
                for (var ix = 0; ix < t1.nvgList.length; ix++) {
                    if (t1.nvgList[ix].empire.id == e2.id) {
                        var d = (t1.max_nvg - t1.empire.nvg);
                        d = (d > 4.0) ? 4.0 : d;
                        p2 += (d * 3.0) / t1.nvgList.length;
                        p1 -= (d * 2.0) / t1.nvgList.length;
                        break;
                    }
                }
            }

            if (e2.mlt > e1.mlt) {
                for (var ix = 0; ix < t1.mltList.length; ix++) {
                    if (t1.mltList[ix].empire.id == e2.id) {
                        var d = (t1.max_mlt - t1.empire.mlt);
                        d = (d > 4.0) ? 4.0 : d;
                        p2 += (d * 3.0) / t1.mltList.length;
                        p1 -= (d * 2.0) / t1.mltList.length;
                        break;
                    }
                }
            }

            p1 = Math.round(p1 * totalDpl / 100);
            p2 = Math.round(p2 * totalDpl / 100);
            t1.trade += p1;
            t2.trade += p2;
            this.tEach[key1] += p1;
            this.tEach[key2] += p2;
        }
    }

    function checkRoute(e1, e2) {
        plist1 = e1.ctlPlanetList;
        plist2 = e2.ctlPlanetList;
        if ( (e1.yoronList[e2.id]) && (e2.yoronList[e1.id]) ) {
        } else {
            return false;
        }

        for (var i = 0; i < plist1.length; i++) {
            for (var j = 0; j < plist2.length; j++) {
                var d = calDistance(plist1[i].loc, plist2[j].loc);
                if ( (d <= e1.fnd) && (d <= e1.nvg) ) {
                    return true;
                }
                if ( (d <= e2.fnd) && (d <= e2.nvg) ) {
                    return true;
                }
            }
        }
        return false;
    }

    return this;

}

// 貿易表示クラス
function clickDispTrade() {
    if (app.selectMode) {
        app.finishSelectMode();
        cancelSCmd();
    }
    var e = document.getElementById("subWindow");
    var body =  document.getElementById("subBody");
    var width = 350;
    var height = 300;
    var imgfile = (isIE()) ? "subwin3.gif" : "subwin3.png";
    app.subWinData.width = width;
    app.subWinData.height = height;

    e.style.width = width + "px";
    e.style.height = height + "px";

    var windowTitle = document.getElementById("windowTitle");
    document.getElementById("windowTitleText").innerHTML="貿易一覧";

    var img = document.getElementById("subwinimg");
    img.setAttribute("src", imgfile);
    var str = '<div id="tradeArea" style="width: 345px; height: 250px">';
    str += "<table bgcolor='ffffff' class='pointTable' style='font-size: 13px;'>";
    str += "<tr bgcolor='444444'>";
    str += "<th nowrap='nowrap'>勢力名</th>";
    str += "<th nowrap='nowrap'>技術力</th>";
    for (var col = 0; col < app.empireList.length; col++) {
        var empire = app.empireList[col];
        if (empire.totalDpl() <= 0) {
            continue;
        }
        str += "<th bgcolor='" + empire.color + "'>";
        str += empire.name.substring(0,3);
        str += "</th>";
    }
    str += "<th nowrap='nowrap'>収支</th>";
    str += "</tr>";
    if (app.trade) {
        var e1 = this.empireList[0];
        for (var row = 0; row < app.empireList.length; row++) {
            var empire1 = app.empireList[row];
            if (empire1.totalDpl() <= 0) {
                continue;
            }
            var e2 = empire1;
            if (BLACK_MODE && (e1.id != e2.id) && (! e1.yoronList[e2.id]) ) {
                continue;
            }
            str += "<tr bgcolor='" + empire1.color + "' style='font-size: 13px;'>";
            str += "<td>" + empire1.name + "</td>";
            str += "<td>" + empire1.fnd
                    + "-" + empire1.nvg
                    + "-" + empire1.mlt
                    + "</td>";
            for (var col = 0; col < app.empireList.length; col++) {
                var empire2 = app.empireList[col];
                if (empire2.totalDpl() <= 0) {
                    continue;
                }
                if (empire1.yoronList[empire2.id]) {
                    var key = empire1.id + "-" + empire2.id;
                    var p = app.trade.tEach[key];
                    if (!p) {
                        p = 0;
                    }
                    var color = empire1.color;
                    if (p < 0) {
                        color = empire2.color;
                    } else if (p > 0) {
                        p = "+" + p;
                    }
                    str += "<td bgcolor='" + color + "' align='right'>";
                    str += p;
                    str += "</td>";
                } else {
                    str += "<td bgcolor='444444' align='center'>-</td>";
                }
            }
            str += "<td align='right'>";
            var p = app.trade.tList[row].trade;
            if (p > 0) {
                p = "+" + p;
            }
            str += p;
            str += "</td>";
            str += "</tr>";
        }
    }
    str += "</table>";
    str += '</div>';

    body.innerHTML = str;
    movingWinInfo.subWindow.disp();

}
